import arcpy, ArcSAGA

class Toolbox(object):
	def __init__(self):
		self.label = "GDAL/OGR"
		self.alias = ""
		self.tools = [tool_1, tool_2, tool_3, tool_4, tool_5, tool_6, tool_7, tool_8, tool_10, tool_12, tool_14]

class tool_1(object):
	def __init__(self):
		self.label = "Export Raster"
		self.description = "<p>The \"GDAL Raster Export\" tool exports one or more grids to various file formats using the \"Geospatial Data Abstraction Library\" (GDAL) by Frank Warmerdam. </p><p>GDAL Version:3.6.2</p><p></p><p>Following raster formats are currently supported:</p><p><table border=\"1\"><tr><th>ID</th><th>Name</th><th>Extension</th></tr></p><p><tr><td>ECW</td><td>ERDAS Compressed Wavelets (SDK 5.5)</td><td>ecw</td></tr><tr><td>JP2ECW</td><td>ERDAS JPEG2000 (SDK 5.5)</td><td>jp2</td></tr><tr><td>FITS</td><td>Flexible Image Transport System</td><td></td></tr><tr><td>HDF4Image</td><td>HDF4 Dataset</td><td></td></tr><tr><td>BAG</td><td>Bathymetry Attributed Grid</td><td>bag</td></tr><tr><td>KEA</td><td>KEA Image Format (.kea)</td><td>kea</td></tr><tr><td>netCDF</td><td>Network Common Data Format</td><td>nc</td></tr><tr><td>PDF</td><td>Geospatial PDF</td><td>pdf</td></tr><tr><td>VRT</td><td>Virtual Raster</td><td>vrt</td></tr><tr><td>GTiff</td><td>GeoTIFF</td><td>tif</td></tr><tr><td>NITF</td><td>National Imagery Transmission Format</td><td>ntf</td></tr><tr><td>HFA</td><td>Erdas Imagine Images (.img)</td><td>img</td></tr><tr><td>ELAS</td><td>ELAS</td><td></td></tr><tr><td>MEM</td><td>In Memory Raster</td><td></td></tr><tr><td>BMP</td><td>MS Windows Device Independent Bitmap</td><td>bmp</td></tr><tr><td>PCIDSK</td><td>PCIDSK Database File</td><td>pix</td></tr><tr><td>PCRaster</td><td>PCRaster Raster File</td><td>map</td></tr><tr><td>ILWIS</td><td>ILWIS Raster Map</td><td></td></tr><tr><td>SGI</td><td>SGI Image File Format 1.0</td><td>rgb</td></tr><tr><td>Leveller</td><td>Leveller heightfield</td><td>ter</td></tr><tr><td>Terragen</td><td>Terragen heightfield</td><td>ter</td></tr><tr><td>ISIS3</td><td>USGS Astrogeology ISIS cube (Version 3)</td><td></td></tr><tr><td>ISIS2</td><td>USGS Astrogeology ISIS cube (Version 2)</td><td></td></tr><tr><td>PDS4</td><td>NASA Planetary Data System 4</td><td>xml</td></tr><tr><td>VICAR</td><td>MIPL VICAR file</td><td></td></tr><tr><td>ERS</td><td>ERMapper .ers Labelled</td><td>ers</td></tr><tr><td>RMF</td><td>Raster Matrix Format</td><td>rsw</td></tr><tr><td>RST</td><td>Idrisi Raster A.1</td><td>rst</td></tr><tr><td>GSBG</td><td>Golden Software Binary Grid (.grd)</td><td>grd</td></tr><tr><td>GS7BG</td><td>Golden Software 7 Binary Grid (.grd)</td><td>grd</td></tr><tr><td>MBTiles</td><td>MBTiles</td><td>mbtiles</td></tr><tr><td>MRF</td><td>Meta Raster Format</td><td>mrf</td></tr><tr><td>PNM</td><td>Portable Pixmap Format (netpbm)</td><td></td></tr><tr><td>PAux</td><td>PCI .aux Labelled</td><td></td></tr><tr><td>MFF</td><td>Vexcel MFF Raster</td><td>hdr</td></tr><tr><td>MFF2</td><td>Vexcel MFF2 (HKV) Raster</td><td></td></tr><tr><td>BT</td><td>VTP .bt (Binary Terrain) 1.3 Format</td><td>bt</td></tr><tr><td>LAN</td><td>Erdas .LAN/.GIS</td><td></td></tr><tr><td>GTX</td><td>NOAA Vertical Datum .GTX</td><td>gtx</td></tr><tr><td>NTv2</td><td>NTv2 Datum Grid Shift</td><td></td></tr><tr><td>CTable2</td><td>CTable2 Datum Grid Shift</td><td></td></tr><tr><td>KRO</td><td>KOLOR Raw</td><td>kro</td></tr><tr><td>ROI_PAC</td><td>ROI_PAC raster</td><td></td></tr><tr><td>RRASTER</td><td>R Raster</td><td>grd</td></tr><tr><td>BYN</td><td>Natural Resources Canada's Geoid</td><td></td></tr><tr><td>NWT_GRD</td><td>Northwood Numeric Grid Format .grd/.tab</td><td>grd</td></tr><tr><td>ADRG</td><td>ARC Digitized Raster Graphics</td><td>gen</td></tr><tr><td>SAGA</td><td>SAGA GIS Binary Grid (.sdat, .sg-grd-z)</td><td></td></tr><tr><td>GPKG</td><td>GeoPackage</td><td>gpkg</td></tr><tr><td>NGW</td><td>NextGIS Web</td><td></td></tr><tr><td>ENVI</td><td>ENVI .hdr Labelled</td><td></td></tr><tr><td>EHdr</td><td>ESRI .hdr Labelled</td><td>bil</td></tr><tr><td>ISCE</td><td>ISCE raster</td><td></td></tr><tr><td>Zarr</td><td>Zarr</td><td></td></tr></table><p><hr><span STYLE=\"font-style:italic;font-size:9pt;font-weight:bold\">SAGA - System for Automated Geoscientific Analyses<br></span><span STYLE=\"font-style:italic;font-size:8pt\">www.saga-gis.org<br></span><span STYLE=\"font-style:italic;font-size:6pt\">_____<br>Reference:<br>Conrad, O., Bechtel, B., Bock, M., Dietrich, H., Fischer, E., Gerlitz, L., Wehberg, J., Wichmann, V., and B__hner, J. (2015): System for Automated Geoscientific Analyses (SAGA) v. 2.1.4, Geosci. Model Dev., 8, 1991-2007, doi:10.5194/gmd-8-1991-2015.</span></p></p>"
		self.canRunInBackground = False

	def getParameterInfo(self):
		param = arcpy.Parameter(displayName="Grid(s)", name="GRIDS", direction="Input", parameterType="Required", datatype="GPRasterLayer", multiValue=True)
		params  = [param]
		param = arcpy.Parameter(displayName="Multiple", name="MULTIPLE", direction="Input", parameterType="Optional", datatype="GPString")
		param.filter.list = ["single files", "one file"]
		param.value = "one file"
		params += [param]
		param = arcpy.Parameter(displayName="Folder", name="FOLDER", direction="Input", parameterType="Optional", datatype="DEFolder")
		params += [param]
		param = arcpy.Parameter(displayName="Extension", name="EXTENSION", direction="Input", parameterType="Optional", datatype="GPString")
		param.value = ""
		params += [param]
		param = arcpy.Parameter(displayName="File", name="FILE", direction="Input", parameterType="Optional", datatype="DEFile")
		params += [param]
		param = arcpy.Parameter(displayName="Format", name="FORMAT", direction="Input", parameterType="Optional", datatype="GPString")
		param.filter.list = ["ERDAS Compressed Wavelets (SDK 5.5)", "ERDAS JPEG2000 (SDK 5.5)", "Flexible Image Transport System", "HDF4 Dataset", "Bathymetry Attributed Grid", "KEA Image Format (.kea)", "Network Common Data Format", "Geospatial PDF", "Virtual Raster", "GeoTIFF", "National Imagery Transmission Format", "Erdas Imagine Images (.img)", "ELAS", "In Memory Raster", "MS Windows Device Independent Bitmap", "PCIDSK Database File", "PCRaster Raster File", "ILWIS Raster Map", "SGI Image File Format 1.0", "Leveller heightfield", "Terragen heightfield", "USGS Astrogeology ISIS cube (Version 3)", "USGS Astrogeology ISIS cube (Version 2)", "NASA Planetary Data System 4", "MIPL VICAR file", "ERMapper .ers Labelled", "Raster Matrix Format", "Idrisi Raster A.1", "Golden Software Binary Grid (.grd)", "Golden Software 7 Binary Grid (.grd)", "MBTiles", "Meta Raster Format", "Portable Pixmap Format (netpbm)", "PCI .aux Labelled", "Vexcel MFF Raster", "Vexcel MFF2 (HKV) Raster", "VTP .bt (Binary Terrain) 1.3 Format", "Erdas .LAN/.GIS", "NOAA Vertical Datum .GTX", "NTv2 Datum Grid Shift", "CTable2 Datum Grid Shift", "KOLOR Raw", "ROI_PAC raster", "R Raster", "Natural Resources Canada's Geoid", "Northwood Numeric Grid Format .grd/.tab", "ARC Digitized Raster Graphics", "SAGA GIS Binary Grid (.sdat, .sg-grd-z)", "GeoPackage", "NextGIS Web", "ENVI .hdr Labelled", "ESRI .hdr Labelled", "ISCE raster", "Zarr"]
		param.value = "ERDAS Compressed Wavelets (SDK 5.5)"
		params += [param]
		param = arcpy.Parameter(displayName="Data Type", name="TYPE", direction="Input", parameterType="Optional", datatype="GPString")
		param.filter.list = ["match input data", "8 bit unsigned integer", "16 bit unsigned integer", "16 bit signed integer", "32 bit unsigned integer", "32 bit signed integer", "32 bit floating point", "64 bit floating point"]
		param.value = "match input data"
		params += [param]
		param = arcpy.Parameter(displayName="Set Custom NoData", name="SET_NODATA", direction="Input", parameterType="Optional", datatype="GPBoolean")
		param.value = False
		params += [param]
		param = arcpy.Parameter(displayName="NoData Value", name="NODATA", direction="Input", parameterType="Optional", datatype="GPDouble")
		param.value = 0.000000
		params += [param]
		param = arcpy.Parameter(displayName="Creation Options", name="OPTIONS", direction="Input", parameterType="Optional", datatype="GPString")
		param.value = ""
		params += [param]
		return params

	def execute(self, parameters, messages):
		Tool = ArcSAGA.SAGA_Tool('io_gdal', '1')
		Tool.Set_Input ('GRIDS', parameters[0].valueAsText, 'grid_list')
		Tool.Set_Option('MULTIPLE', parameters[1].valueAsText)
		Tool.Set_Option('FOLDER', parameters[2].valueAsText)
		Tool.Set_Option('EXTENSION', parameters[3].valueAsText)
		Tool.Set_Option('FILE', parameters[4].valueAsText)
		Tool.Set_Option('FORMAT', parameters[5].valueAsText)
		Tool.Set_Option('TYPE', parameters[6].valueAsText)
		Tool.Set_Option('SET_NODATA', parameters[7].valueAsText)
		Tool.Set_Option('NODATA', parameters[8].valueAsText)
		Tool.Set_Option('OPTIONS', parameters[9].valueAsText)
		Tool.Run()
		return


class tool_2(object):
	def __init__(self):
		self.label = "Export GeoTIFF"
		self.description = "<p>The \"GDAL GeoTIFF Export\" tool exports one or more grids to a Geocoded Tagged Image File Format using the \"Geospatial Data Abstraction Library\" (GDAL) by Frank Warmerdam. <p><hr><span STYLE=\"font-style:italic;font-size:9pt;font-weight:bold\">SAGA - System for Automated Geoscientific Analyses<br></span><span STYLE=\"font-style:italic;font-size:8pt\">www.saga-gis.org<br></span><span STYLE=\"font-style:italic;font-size:6pt\">_____<br>Reference:<br>Conrad, O., Bechtel, B., Bock, M., Dietrich, H., Fischer, E., Gerlitz, L., Wehberg, J., Wichmann, V., and B__hner, J. (2015): System for Automated Geoscientific Analyses (SAGA) v. 2.1.4, Geosci. Model Dev., 8, 1991-2007, doi:10.5194/gmd-8-1991-2015.</span></p></p>"
		self.canRunInBackground = False

	def getParameterInfo(self):
		param = arcpy.Parameter(displayName="Grid(s)", name="GRIDS", direction="Input", parameterType="Required", datatype="GPRasterLayer", multiValue=True)
		params  = [param]
		param = arcpy.Parameter(displayName="File", name="FILE", direction="Input", parameterType="Optional", datatype="DEFile")
		params += [param]
		param = arcpy.Parameter(displayName="Creation Options", name="OPTIONS", direction="Input", parameterType="Optional", datatype="GPString")
		param.value = ""
		params += [param]
		return params

	def execute(self, parameters, messages):
		Tool = ArcSAGA.SAGA_Tool('io_gdal', '2')
		Tool.Set_Input ('GRIDS', parameters[0].valueAsText, 'grid_list')
		Tool.Set_Option('FILE', parameters[1].valueAsText)
		Tool.Set_Option('OPTIONS', parameters[2].valueAsText)
		Tool.Run()
		return


class tool_3(object):
	def __init__(self):
		self.label = "Import Shapes"
		self.description = "<p>The \"OGR Vector Data Import\" tool imports vector data from various file/database formats using the \"Geospatial Data Abstraction Library\" (GDAL) by Frank Warmerdam. </p><p>GDAL Version:3.6.2</p><p></p><p>Following raster formats are currently supported:</p><p><table border=\"1\"><tr><th>ID</th><th>Name</th><th>Extension</th></tr><tr><td>JP2ECW</td><td>ERDAS JPEG2000 (SDK 5.5)</td><td>jp2</td></tr><tr><td>FITS</td><td>Flexible Image Transport System</td><td></td></tr><tr><td>BAG</td><td>Bathymetry Attributed Grid</td><td>bag</td></tr><tr><td>netCDF</td><td>Network Common Data Format</td><td>nc</td></tr><tr><td>PDF</td><td>Geospatial PDF</td><td>pdf</td></tr><tr><td>FileGDB</td><td>ESRI FileGDB</td><td>gdb</td></tr><tr><td>ODBC</td><td></td><td></td></tr><tr><td>PCIDSK</td><td>PCIDSK Database File</td><td>pix</td></tr><tr><td>PDS4</td><td>NASA Planetary Data System 4</td><td>xml</td></tr><tr><td>VICAR</td><td>MIPL VICAR file</td><td></td></tr><tr><td>JP2OpenJPEG</td><td>JPEG-2000 driver based on OpenJPEG library</td><td>jp2</td></tr><tr><td>MBTiles</td><td>MBTiles</td><td>mbtiles</td></tr><tr><td>EEDA</td><td>Earth Engine Data API</td><td></td></tr><tr><td>OGCAPI</td><td>OGCAPI</td><td></td></tr><tr><td>ESRI Shapefile</td><td>ESRI Shapefile</td><td>shp</td></tr><tr><td>MapInfo File</td><td>MapInfo File</td><td></td></tr><tr><td>UK .NTF</td><td>UK .NTF</td><td></td></tr><tr><td>LVBAG</td><td>Kadaster LV BAG Extract 2.0</td><td>xml</td></tr><tr><td>OGR_SDTS</td><td>SDTS</td><td></td></tr><tr><td>S57</td><td>IHO S-57 (ENC)</td><td>000</td></tr><tr><td>DGN</td><td>Microstation DGN</td><td>dgn</td></tr><tr><td>OGR_VRT</td><td>VRT - Virtual Datasource</td><td>vrt</td></tr><tr><td>Memory</td><td>Memory</td><td></td></tr><tr><td>CSV</td><td>Comma Separated Value (.csv)</td><td>csv</td></tr><tr><td>NAS</td><td>NAS - ALKIS</td><td>xml</td></tr><tr><td>GML</td><td>Geography Markup Language (GML)</td><td>gml</td></tr><tr><td>GPX</td><td>GPX</td><td>gpx</td></tr><tr><td>LIBKML</td><td>Keyhole Markup Language (LIBKML)</td><td></td></tr><tr><td>KML</td><td>Keyhole Markup Language (KML)</td><td>kml</td></tr><tr><td>GeoJSON</td><td>GeoJSON</td><td></td></tr><tr><td>GeoJSONSeq</td><td>GeoJSON Sequence</td><td></td></tr><tr><td>ESRIJSON</td><td>ESRIJSON</td><td>json</td></tr><tr><td>TopoJSON</td><td>TopoJSON</td><td></td></tr><tr><td>Interlis 1</td><td>Interlis 1</td><td></td></tr><tr><td>Interlis 2</td><td>Interlis 2</td><td></td></tr><tr><td>OGR_GMT</td><td>GMT ASCII Vectors (.gmt)</td><td>gmt</td></tr><tr><td>GPKG</td><td>GeoPackage</td><td>gpkg</td></tr><tr><td>SQLite</td><td>SQLite / Spatialite</td><td></td></tr><tr><td>WAsP</td><td>WAsP .map format</td><td>map</td></tr><tr><td>PGeo</td><td>ESRI Personal GeoDatabase</td><td>mdb</td></tr><tr><td>OGR_OGDI</td><td>OGDI Vectors (VPF, VMAP, DCW)</td><td></td></tr><tr><td>PostgreSQL</td><td>PostgreSQL/PostGIS</td><td></td></tr><tr><td>MySQL</td><td>MySQL</td><td></td></tr><tr><td>OpenFileGDB</td><td>ESRI FileGDB</td><td>gdb</td></tr><tr><td>DXF</td><td>AutoCAD DXF</td><td>dxf</td></tr><tr><td>CAD</td><td>AutoCAD Driver</td><td>dwg</td></tr><tr><td>FlatGeobuf</td><td>FlatGeobuf</td><td>fgb</td></tr><tr><td>Geoconcept</td><td>Geoconcept</td><td></td></tr><tr><td>GeoRSS</td><td>GeoRSS</td><td></td></tr><tr><td>VFK</td><td>Czech Cadastral Exchange Data Format</td><td>vfk</td></tr><tr><td>PGDUMP</td><td>PostgreSQL SQL dump</td><td>sql</td></tr><tr><td>OSM</td><td>OpenStreetMap XML and PBF</td><td></td></tr><tr><td>GPSBabel</td><td>GPSBabel</td><td></td></tr><tr><td>OGR_PDS</td><td>Planetary Data Systems TABLE</td><td></td></tr><tr><td>WFS</td><td>OGC WFS (Web Feature Service)</td><td></td></tr><tr><td>OAPIF</td><td>OGC API - Features</td><td></td></tr><tr><td>EDIGEO</td><td>French EDIGEO exchange format</td><td>thf</td></tr><tr><td>SVG</td><td>Scalable Vector Graphics</td><td>svg</td></tr><tr><td>Idrisi</td><td>Idrisi Vector (.vct)</td><td>vct</td></tr><tr><td>XLS</td><td>MS Excel format</td><td>xls</td></tr><tr><td>ODS</td><td>Open Document/ LibreOffice / OpenOffice Spreadsheet </td><td>ods</td></tr><tr><td>XLSX</td><td>MS Office Open XML spreadsheet</td><td></td></tr><tr><td>Elasticsearch</td><td>Elastic Search</td><td></td></tr><tr><td>Carto</td><td>Carto</td><td></td></tr><tr><td>AmigoCloud</td><td>AmigoCloud</td><td></td></tr><tr><td>SXF</td><td>Storage and eXchange Format</td><td>sxf</td></tr><tr><td>Selafin</td><td>Selafin</td><td></td></tr><tr><td>JML</td><td>OpenJUMP JML</td><td>jml</td></tr><tr><td>PLSCENES</td><td>Planet Labs Scenes API</td><td></td></tr><tr><td>CSW</td><td>OGC CSW (Catalog  Service for the Web)</td><td></td></tr><tr><td>VDV</td><td>VDV-451/VDV-452/INTREST Data Format</td><td></td></tr><tr><td>GMLAS</td><td>Geography Markup Language (GML) driven by application schemas</td><td></td></tr><tr><td>MVT</td><td>Mapbox Vector Tiles</td><td></td></tr><tr><td>NGW</td><td>NextGIS Web</td><td></td></tr><tr><td>MapML</td><td>MapML</td><td></td></tr><tr><td>TIGER</td><td>U.S. Census TIGER/Line</td><td></td></tr><tr><td>AVCBin</td><td>Arc/Info Binary Coverage</td><td></td></tr><tr><td>AVCE00</td><td>Arc/Info E00 (ASCII) Coverage</td><td>e00</td></tr><tr><td>HTTP</td><td>HTTP Fetching Wrapper</td><td></td></tr></table><p><hr><span STYLE=\"font-style:italic;font-size:9pt;font-weight:bold\">SAGA - System for Automated Geoscientific Analyses<br></span><span STYLE=\"font-style:italic;font-size:8pt\">www.saga-gis.org<br></span><span STYLE=\"font-style:italic;font-size:6pt\">_____<br>Reference:<br>Conrad, O., Bechtel, B., Bock, M., Dietrich, H., Fischer, E., Gerlitz, L., Wehberg, J., Wichmann, V., and B__hner, J. (2015): System for Automated Geoscientific Analyses (SAGA) v. 2.1.4, Geosci. Model Dev., 8, 1991-2007, doi:10.5194/gmd-8-1991-2015.</span></p></p>"
		self.canRunInBackground = False

	def getParameterInfo(self):
		param = arcpy.Parameter(displayName="Shapes", name="SHAPES", direction="Output", parameterType="Required", datatype="GPFeatureLayer", multiValue=True)
		params  = [param]
		param = arcpy.Parameter(displayName="Files", name="FILES", direction="Input", parameterType="Optional", datatype="DEFile", multiValue=True)
		params += [param]
		param = arcpy.Parameter(displayName="Geometry Type", name="GEOM_TYPE", direction="Input", parameterType="Optional", datatype="GPString")
		param.filter.list = ["Automatic", "Point", "Point (2.5D)", "Multi-Point", "Multi-Point (2.5D)", "Line", "Line (2.5D)", "Polyline", "Polyline (2.5D)", "Polygon", "Polygon (2.5D)", "Multi-Polygon", "Multi-Polygon (2.5D)"]
		param.value = "Automatic"
		params += [param]
		return params

	def execute(self, parameters, messages):
		Tool = ArcSAGA.SAGA_Tool('io_gdal', '3')
		Tool.Set_Output('SHAPES', parameters[0].valueAsText, 'shapes_list')
		Tool.Set_Option('FILES', parameters[1].valueAsText)
		Tool.Set_Option('GEOM_TYPE', parameters[2].valueAsText)
		Tool.Run()
		return


class tool_4(object):
	def __init__(self):
		self.label = "Export Shapes"
		self.description = "<p>The \"OGR Vector Data Export\" tool exports vector data to various file formats using the \"Geospatial Data Abstraction Library\" (GDAL) by Frank Warmerdam. </p><p>GDAL Version:3.6.2</p><p></p><p>Following vector formats are currently supported:</p><p><table border=\"1\"><tr><th>ID</th><th>Name</th><th>Extension</th></tr></p><p><tr><td>JP2ECW</td><td>ERDAS JPEG2000 (SDK 5.5)</td><td>jp2</td></tr><tr><td>FITS</td><td>Flexible Image Transport System</td><td></td></tr><tr><td>BAG</td><td>Bathymetry Attributed Grid</td><td>bag</td></tr><tr><td>netCDF</td><td>Network Common Data Format</td><td>nc</td></tr><tr><td>PDF</td><td>Geospatial PDF</td><td>pdf</td></tr><tr><td>FileGDB</td><td>ESRI FileGDB</td><td>gdb</td></tr><tr><td>PCIDSK</td><td>PCIDSK Database File</td><td>pix</td></tr><tr><td>PDS4</td><td>NASA Planetary Data System 4</td><td>xml</td></tr><tr><td>VICAR</td><td>MIPL VICAR file</td><td></td></tr><tr><td>MBTiles</td><td>MBTiles</td><td>mbtiles</td></tr><tr><td>ESRI Shapefile</td><td>ESRI Shapefile</td><td>shp</td></tr><tr><td>MapInfo File</td><td>MapInfo File</td><td></td></tr><tr><td>S57</td><td>IHO S-57 (ENC)</td><td>000</td></tr><tr><td>DGN</td><td>Microstation DGN</td><td>dgn</td></tr><tr><td>Memory</td><td>Memory</td><td></td></tr><tr><td>CSV</td><td>Comma Separated Value (.csv)</td><td>csv</td></tr><tr><td>GML</td><td>Geography Markup Language (GML)</td><td>gml</td></tr><tr><td>GPX</td><td>GPX</td><td>gpx</td></tr><tr><td>LIBKML</td><td>Keyhole Markup Language (LIBKML)</td><td></td></tr><tr><td>KML</td><td>Keyhole Markup Language (KML)</td><td>kml</td></tr><tr><td>GeoJSON</td><td>GeoJSON</td><td></td></tr><tr><td>GeoJSONSeq</td><td>GeoJSON Sequence</td><td></td></tr><tr><td>Interlis 1</td><td>Interlis 1</td><td></td></tr><tr><td>Interlis 2</td><td>Interlis 2</td><td></td></tr><tr><td>OGR_GMT</td><td>GMT ASCII Vectors (.gmt)</td><td>gmt</td></tr><tr><td>GPKG</td><td>GeoPackage</td><td>gpkg</td></tr><tr><td>SQLite</td><td>SQLite / Spatialite</td><td></td></tr><tr><td>WAsP</td><td>WAsP .map format</td><td>map</td></tr><tr><td>PostgreSQL</td><td>PostgreSQL/PostGIS</td><td></td></tr><tr><td>MySQL</td><td>MySQL</td><td></td></tr><tr><td>OpenFileGDB</td><td>ESRI FileGDB</td><td>gdb</td></tr><tr><td>DXF</td><td>AutoCAD DXF</td><td>dxf</td></tr><tr><td>FlatGeobuf</td><td>FlatGeobuf</td><td>fgb</td></tr><tr><td>Geoconcept</td><td>Geoconcept</td><td></td></tr><tr><td>GeoRSS</td><td>GeoRSS</td><td></td></tr><tr><td>PGDUMP</td><td>PostgreSQL SQL dump</td><td>sql</td></tr><tr><td>GPSBabel</td><td>GPSBabel</td><td></td></tr><tr><td>ODS</td><td>Open Document/ LibreOffice / OpenOffice Spreadsheet </td><td>ods</td></tr><tr><td>XLSX</td><td>MS Office Open XML spreadsheet</td><td></td></tr><tr><td>Elasticsearch</td><td>Elastic Search</td><td></td></tr><tr><td>Carto</td><td>Carto</td><td></td></tr><tr><td>AmigoCloud</td><td>AmigoCloud</td><td></td></tr><tr><td>Selafin</td><td>Selafin</td><td></td></tr><tr><td>JML</td><td>OpenJUMP JML</td><td>jml</td></tr><tr><td>VDV</td><td>VDV-451/VDV-452/INTREST Data Format</td><td></td></tr><tr><td>MVT</td><td>Mapbox Vector Tiles</td><td></td></tr><tr><td>NGW</td><td>NextGIS Web</td><td></td></tr><tr><td>MapML</td><td>MapML</td><td></td></tr></table><p><hr><span STYLE=\"font-style:italic;font-size:9pt;font-weight:bold\">SAGA - System for Automated Geoscientific Analyses<br></span><span STYLE=\"font-style:italic;font-size:8pt\">www.saga-gis.org<br></span><span STYLE=\"font-style:italic;font-size:6pt\">_____<br>Reference:<br>Conrad, O., Bechtel, B., Bock, M., Dietrich, H., Fischer, E., Gerlitz, L., Wehberg, J., Wichmann, V., and B__hner, J. (2015): System for Automated Geoscientific Analyses (SAGA) v. 2.1.4, Geosci. Model Dev., 8, 1991-2007, doi:10.5194/gmd-8-1991-2015.</span></p></p>"
		self.canRunInBackground = False

	def getParameterInfo(self):
		param = arcpy.Parameter(displayName="Shapes", name="SHAPES", direction="Input", parameterType="Required", datatype="GPFeatureLayer")
		params  = [param]
		param = arcpy.Parameter(displayName="File", name="FILE", direction="Input", parameterType="Optional", datatype="DEFile")
		params += [param]
		param = arcpy.Parameter(displayName="Format", name="FORMAT", direction="Input", parameterType="Optional", datatype="GPString")
		param.filter.list = ["ERDAS JPEG2000 (SDK 5.5)", "Flexible Image Transport System", "Bathymetry Attributed Grid", "Network Common Data Format", "Geospatial PDF", "ESRI FileGDB", "PCIDSK Database File", "NASA Planetary Data System 4", "MIPL VICAR file", "MBTiles", "ESRI Shapefile", "MapInfo File", "IHO S-57 (ENC)", "Microstation DGN", "Memory", "Comma Separated Value (.csv)", "Geography Markup Language (GML)", "GPX", "Keyhole Markup Language (LIBKML)", "Keyhole Markup Language (KML)", "GeoJSON", "GeoJSON Sequence", "Interlis 1", "Interlis 2", "GMT ASCII Vectors (.gmt)", "GeoPackage", "SQLite / Spatialite", "WAsP .map format", "PostgreSQL/PostGIS", "MySQL", "ESRI FileGDB", "AutoCAD DXF", "FlatGeobuf", "Geoconcept", "GeoRSS", "PostgreSQL SQL dump", "GPSBabel", "Open Document/ LibreOffice / OpenOffice Spreadsheet ", "MS Office Open XML spreadsheet", "Elastic Search", "Carto", "AmigoCloud", "Selafin", "OpenJUMP JML", "VDV-451/VDV-452/INTREST Data Format", "Mapbox Vector Tiles", "NextGIS Web", "MapML"]
		param.value = "ERDAS JPEG2000 (SDK 5.5)"
		params += [param]
		param = arcpy.Parameter(displayName="Creation Options", name="OPTIONS", direction="Input", parameterType="Optional", datatype="GPString")
		param.value = ""
		params += [param]
		param = arcpy.Parameter(displayName="Layer Creation Options", name="LAYER_OPTIONS", direction="Input", parameterType="Optional", datatype="GPString")
		param.value = ""
		params += [param]
		return params

	def execute(self, parameters, messages):
		Tool = ArcSAGA.SAGA_Tool('io_gdal', '4')
		Tool.Set_Input ('SHAPES', parameters[0].valueAsText, 'shapes')
		Tool.Set_Option('FILE', parameters[1].valueAsText)
		Tool.Set_Option('FORMAT', parameters[2].valueAsText)
		Tool.Set_Option('OPTIONS', parameters[3].valueAsText)
		Tool.Set_Option('LAYER_OPTIONS', parameters[4].valueAsText)
		Tool.Run()
		return


class tool_5(object):
	def __init__(self):
		self.label = "Export Shapes to KML"
		self.description = "<p>This tool exports a vector layer to the Google Earth KML format using Frank Warmerdam's \"Geospatial Data Abstraction Library\" (GDAL/OGR). The output file is projected to geographic coordinates if necessary and possible. <p><hr><span STYLE=\"font-style:italic;font-size:9pt;font-weight:bold\">SAGA - System for Automated Geoscientific Analyses<br></span><span STYLE=\"font-style:italic;font-size:8pt\">www.saga-gis.org<br></span><span STYLE=\"font-style:italic;font-size:6pt\">_____<br>Reference:<br>Conrad, O., Bechtel, B., Bock, M., Dietrich, H., Fischer, E., Gerlitz, L., Wehberg, J., Wichmann, V., and B__hner, J. (2015): System for Automated Geoscientific Analyses (SAGA) v. 2.1.4, Geosci. Model Dev., 8, 1991-2007, doi:10.5194/gmd-8-1991-2015.</span></p></p>"
		self.canRunInBackground = False

	def getParameterInfo(self):
		param = arcpy.Parameter(displayName="Shapes", name="SHAPES", direction="Input", parameterType="Required", datatype="GPFeatureLayer")
		params  = [param]
		param = arcpy.Parameter(displayName="File", name="FILE", direction="Input", parameterType="Optional", datatype="DEFile")
		params += [param]
		return params

	def execute(self, parameters, messages):
		Tool = ArcSAGA.SAGA_Tool('io_gdal', '5')
		Tool.Set_Input ('SHAPES', parameters[0].valueAsText, 'shapes')
		Tool.Set_Option('FILE', parameters[1].valueAsText)
		Tool.Run()
		return


class tool_6(object):
	def __init__(self):
		self.label = "Import NetCDF"
		self.description = "<p>This tool imports grids NetCDF Format using the \"Geospatial Data Abstraction Library\" (GDAL) by Frank Warmerdam. <p><hr><span STYLE=\"font-style:italic;font-size:9pt;font-weight:bold\">SAGA - System for Automated Geoscientific Analyses<br></span><span STYLE=\"font-style:italic;font-size:8pt\">www.saga-gis.org<br></span><span STYLE=\"font-style:italic;font-size:6pt\">_____<br>Reference:<br>Conrad, O., Bechtel, B., Bock, M., Dietrich, H., Fischer, E., Gerlitz, L., Wehberg, J., Wichmann, V., and B__hner, J. (2015): System for Automated Geoscientific Analyses (SAGA) v. 2.1.4, Geosci. Model Dev., 8, 1991-2007, doi:10.5194/gmd-8-1991-2015.</span></p></p>"
		self.canRunInBackground = False

	def getParameterInfo(self):
		param = arcpy.Parameter(displayName="Grids", name="GRIDS", direction="Output", parameterType="Required", datatype="GPRasterLayer", multiValue=True)
		params  = [param]
		param = arcpy.Parameter(displayName="File", name="FILE", direction="Input", parameterType="Optional", datatype="DEFile")
		params += [param]
		param = arcpy.Parameter(displayName="Save to File", name="SAVE_FILE", direction="Input", parameterType="Optional", datatype="GPBoolean")
		param.value = False
		params += [param]
		param = arcpy.Parameter(displayName="Save to Path", name="SAVE_PATH", direction="Input", parameterType="Optional", datatype="DEFolder")
		params += [param]
		param = arcpy.Parameter(displayName="Transformation", name="TRANSFORM", direction="Input", parameterType="Optional", datatype="GPBoolean")
		param.value = True
		params += [param]
		param = arcpy.Parameter(displayName="Resampling", name="RESAMPLING", direction="Input", parameterType="Optional", datatype="GPString")
		param.filter.list = ["Nearest Neighbour", "Bilinear Interpolation", "Bicubic Spline Interpolation", "B-Spline Interpolation"]
		param.value = "B-Spline Interpolation"
		params += [param]
		return params

	def execute(self, parameters, messages):
		Tool = ArcSAGA.SAGA_Tool('io_gdal', '6')
		Tool.Set_Output('GRIDS', parameters[0].valueAsText, 'grid_list')
		Tool.Set_Option('FILE', parameters[1].valueAsText)
		Tool.Set_Option('SAVE_FILE', parameters[2].valueAsText)
		Tool.Set_Option('SAVE_PATH', parameters[3].valueAsText)
		Tool.Set_Option('TRANSFORM', parameters[4].valueAsText)
		Tool.Set_Option('RESAMPLING', parameters[5].valueAsText)
		Tool.Run()
		return


class tool_7(object):
	def __init__(self):
		self.label = "Create Raster Catalogue from Files"
		self.description = "<p>Create a raster catalogue from selected files. Output is a polygon layer that shows the extent for each valid raster file. Each extent is attributed with the original file path and raster system properties.</p><p></p><p>The \"GDAL Raster Import\" tool imports grid data from various file formats using the \"Geospatial Data Abstraction Library\" (GDAL) by Frank Warmerdam. </p><p>GDAL Version:3.6.2</p><p></p><p>Following raster formats are currently supported:</p><p><table border=\"1\"><tr><th>ID</th><th>Name</th></tr></p><p><tr><td>ECW</td><td>ERDAS Compressed Wavelets (SDK 5.5)</td></tr></p><p><tr><td>JP2ECW</td><td>ERDAS JPEG2000 (SDK 5.5)</td></tr></p><p><tr><td>FITS</td><td>Flexible Image Transport System</td></tr></p><p><tr><td>HDF4</td><td>Hierarchical Data Format Release 4</td></tr></p><p><tr><td>HDF4Image</td><td>HDF4 Dataset</td></tr></p><p><tr><td>HDF5</td><td>Hierarchical Data Format Release 5</td></tr></p><p><tr><td>HDF5Image</td><td>HDF5 Dataset</td></tr></p><p><tr><td>BAG</td><td>Bathymetry Attributed Grid</td></tr></p><p><tr><td>KEA</td><td>KEA Image Format (.kea)</td></tr></p><p><tr><td>netCDF</td><td>Network Common Data Format</td></tr></p><p><tr><td>PDF</td><td>Geospatial PDF</td></tr></p><p><tr><td>FileGDB</td><td>ESRI FileGDB</td></tr></p><p><tr><td>ODBC</td><td></td></tr></p><p><tr><td>VRT</td><td>Virtual Raster</td></tr></p><p><tr><td>DERIVED</td><td>Derived datasets using VRT pixel functions</td></tr></p><p><tr><td>GTiff</td><td>GeoTIFF</td></tr></p><p><tr><td>COG</td><td>Cloud optimized GeoTIFF generator</td></tr></p><p><tr><td>NITF</td><td>National Imagery Transmission Format</td></tr></p><p><tr><td>RPFTOC</td><td>Raster Product Format TOC format</td></tr></p><p><tr><td>ECRGTOC</td><td>ECRG TOC format</td></tr></p><p><tr><td>HFA</td><td>Erdas Imagine Images (.img)</td></tr></p><p><tr><td>SAR_CEOS</td><td>CEOS SAR Image</td></tr></p><p><tr><td>CEOS</td><td>CEOS Image</td></tr></p><p><tr><td>JAXAPALSAR</td><td>JAXA PALSAR Product Reader (Level 1.1/1.5)</td></tr></p><p><tr><td>GFF</td><td>Ground-based SAR Applications Testbed File Format (.gff)</td></tr></p><p><tr><td>ELAS</td><td>ELAS</td></tr></p><p><tr><td>ESRIC</td><td>Esri Compact Cache</td></tr></p><p><tr><td>AIG</td><td>Arc/Info Binary Grid</td></tr></p><p><tr><td>AAIGrid</td><td>Arc/Info ASCII Grid</td></tr></p><p><tr><td>GRASSASCIIGrid</td><td>GRASS ASCII Grid</td></tr></p><p><tr><td>ISG</td><td>International Service for the Geoid</td></tr></p><p><tr><td>SDTS</td><td>SDTS Raster</td></tr></p><p><tr><td>DTED</td><td>DTED Elevation Raster</td></tr></p><p><tr><td>PNG</td><td>Portable Network Graphics</td></tr></p><p><tr><td>JPEG</td><td>JPEG JFIF</td></tr></p><p><tr><td>MEM</td><td>In Memory Raster</td></tr></p><p><tr><td>JDEM</td><td>Japanese DEM (.mem)</td></tr></p><p><tr><td>GIF</td><td>Graphics Interchange Format (.gif)</td></tr></p><p><tr><td>BIGGIF</td><td>Graphics Interchange Format (.gif)</td></tr></p><p><tr><td>ESAT</td><td>Envisat Image Format</td></tr></p><p><tr><td>BSB</td><td>Maptech BSB Nautical Charts</td></tr></p><p><tr><td>XPM</td><td>X11 PixMap Format</td></tr></p><p><tr><td>BMP</td><td>MS Windows Device Independent Bitmap</td></tr></p><p><tr><td>DIMAP</td><td>SPOT DIMAP</td></tr></p><p><tr><td>AirSAR</td><td>AirSAR Polarimetric Image</td></tr></p><p><tr><td>RS2</td><td>RadarSat 2 XML Product</td></tr></p><p><tr><td>SAFE</td><td>Sentinel-1 SAR SAFE Product</td></tr></p><p><tr><td>PCIDSK</td><td>PCIDSK Database File</td></tr></p><p><tr><td>PCRaster</td><td>PCRaster Raster File</td></tr></p><p><tr><td>ILWIS</td><td>ILWIS Raster Map</td></tr></p><p><tr><td>SGI</td><td>SGI Image File Format 1.0</td></tr></p><p><tr><td>SRTMHGT</td><td>SRTMHGT File Format</td></tr></p><p><tr><td>Leveller</td><td>Leveller heightfield</td></tr></p><p><tr><td>Terragen</td><td>Terragen heightfield</td></tr></p><p><tr><td>ISIS3</td><td>USGS Astrogeology ISIS cube (Version 3)</td></tr></p><p><tr><td>ISIS2</td><td>USGS Astrogeology ISIS cube (Version 2)</td></tr></p><p><tr><td>PDS</td><td>NASA Planetary Data System</td></tr></p><p><tr><td>PDS4</td><td>NASA Planetary Data System 4</td></tr></p><p><tr><td>VICAR</td><td>MIPL VICAR file</td></tr></p><p><tr><td>TIL</td><td>EarthWatch .TIL</td></tr></p><p><tr><td>ERS</td><td>ERMapper .ers Labelled</td></tr></p><p><tr><td>JP2OpenJPEG</td><td>JPEG-2000 driver based on OpenJPEG library</td></tr></p><p><tr><td>L1B</td><td>NOAA Polar Orbiter Level 1b Data Set</td></tr></p><p><tr><td>FIT</td><td>FIT Image</td></tr></p><p><tr><td>GRIB</td><td>GRIdded Binary (.grb, .grb2)</td></tr></p><p><tr><td>RMF</td><td>Raster Matrix Format</td></tr></p><p><tr><td>WCS</td><td>OGC Web Coverage Service</td></tr></p><p><tr><td>WMS</td><td>OGC Web Map Service</td></tr></p><p><tr><td>MSGN</td><td>EUMETSAT Archive native (.nat)</td></tr></p><p><tr><td>RST</td><td>Idrisi Raster A.1</td></tr></p><p><tr><td>GSAG</td><td>Golden Software ASCII Grid (.grd)</td></tr></p><p><tr><td>GSBG</td><td>Golden Software Binary Grid (.grd)</td></tr></p><p><tr><td>GS7BG</td><td>Golden Software 7 Binary Grid (.grd)</td></tr></p><p><tr><td>COSAR</td><td>COSAR Annotated Binary Matrix (TerraSAR-X)</td></tr></p><p><tr><td>TSX</td><td>TerraSAR-X Product</td></tr></p><p><tr><td>COASP</td><td>DRDC COASP SAR Processor Raster</td></tr></p><p><tr><td>R</td><td>R Object Data Store</td></tr></p><p><tr><td>MAP</td><td>OziExplorer .MAP</td></tr></p><p><tr><td>KMLSUPEROVERLAY</td><td>Kml Super Overlay</td></tr></p><p><tr><td>WEBP</td><td>WEBP</td></tr></p><p><tr><td>Rasterlite</td><td>Rasterlite</td></tr></p><p><tr><td>MBTiles</td><td>MBTiles</td></tr></p><p><tr><td>PLMOSAIC</td><td>Planet Labs Mosaics API</td></tr></p><p><tr><td>CALS</td><td>CALS (Type 1)</td></tr></p><p><tr><td>WMTS</td><td>OGC Web Map Tile Service</td></tr></p><p><tr><td>SENTINEL2</td><td>Sentinel 2</td></tr></p><p><tr><td>MRF</td><td>Meta Raster Format</td></tr></p><p><tr><td>PNM</td><td>Portable Pixmap Format (netpbm)</td></tr></p><p><tr><td>DOQ1</td><td>USGS DOQ (Old Style)</td></tr></p><p><tr><td>DOQ2</td><td>USGS DOQ (New Style)</td></tr></p><p><tr><td>PAux</td><td>PCI .aux Labelled</td></tr></p><p><tr><td>MFF</td><td>Vexcel MFF Raster</td></tr></p><p><tr><td>MFF2</td><td>Vexcel MFF2 (HKV) Raster</td></tr></p><p><tr><td>GSC</td><td>GSC Geogrid</td></tr></p><p><tr><td>FAST</td><td>EOSAT FAST Format</td></tr></p><p><tr><td>BT</td><td>VTP .bt (Binary Terrain) 1.3 Format</td></tr></p><p><tr><td>LAN</td><td>Erdas .LAN/.GIS</td></tr></p><p><tr><td>CPG</td><td>Convair PolGASP</td></tr></p><p><tr><td>NDF</td><td>NLAPS Data Format</td></tr></p><p><tr><td>EIR</td><td>Erdas Imagine Raw</td></tr></p><p><tr><td>DIPEx</td><td>DIPEx</td></tr></p><p><tr><td>LCP</td><td>FARSITE v.4 Landscape File (.lcp)</td></tr></p><p><tr><td>GTX</td><td>NOAA Vertical Datum .GTX</td></tr></p><p><tr><td>LOSLAS</td><td>NADCON .los/.las Datum Grid Shift</td></tr></p><p><tr><td>NTv2</td><td>NTv2 Datum Grid Shift</td></tr></p><p><tr><td>CTable2</td><td>CTable2 Datum Grid Shift</td></tr></p><p><tr><td>ACE2</td><td>ACE2</td></tr></p><p><tr><td>SNODAS</td><td>Snow Data Assimilation System</td></tr></p><p><tr><td>KRO</td><td>KOLOR Raw</td></tr></p><p><tr><td>ROI_PAC</td><td>ROI_PAC raster</td></tr></p><p><tr><td>RRASTER</td><td>R Raster</td></tr></p><p><tr><td>BYN</td><td>Natural Resources Canada's Geoid</td></tr></p><p><tr><td>ARG</td><td>Azavea Raster Grid format</td></tr></p><p><tr><td>RIK</td><td>Swedish Grid RIK (.rik)</td></tr></p><p><tr><td>USGSDEM</td><td>USGS Optional ASCII DEM (and CDED)</td></tr></p><p><tr><td>GXF</td><td>GeoSoft Grid Exchange Format</td></tr></p><p><tr><td>NWT_GRD</td><td>Northwood Numeric Grid Format .grd/.tab</td></tr></p><p><tr><td>NWT_GRC</td><td>Northwood Classified Grid Format .grc/.tab</td></tr></p><p><tr><td>ADRG</td><td>ARC Digitized Raster Graphics</td></tr></p><p><tr><td>SRP</td><td>Standard Raster Product (ASRP/USRP)</td></tr></p><p><tr><td>BLX</td><td>Magellan topo (.blx)</td></tr></p><p><tr><td>PostGISRaster</td><td>PostGIS Raster driver</td></tr></p><p><tr><td>SAGA</td><td>SAGA GIS Binary Grid (.sdat, .sg-grd-z)</td></tr></p><p><tr><td>XYZ</td><td>ASCII Gridded XYZ</td></tr></p><p><tr><td>HF2</td><td>HF2/HFZ heightfield raster</td></tr></p><p><tr><td>OZI</td><td>OziExplorer Image File</td></tr></p><p><tr><td>CTG</td><td>USGS LULC Composite Theme Grid</td></tr></p><p><tr><td>ZMap</td><td>ZMap Plus Grid</td></tr></p><p><tr><td>NGSGEOID</td><td>NOAA NGS Geoid Height Grids</td></tr></p><p><tr><td>IRIS</td><td>IRIS data (.PPI, .CAPPi etc)</td></tr></p><p><tr><td>PRF</td><td>Racurs PHOTOMOD PRF</td></tr></p><p><tr><td>EEDAI</td><td>Earth Engine Data API Image</td></tr></p><p><tr><td>EEDA</td><td>Earth Engine Data API</td></tr></p><p><tr><td>DAAS</td><td>Airbus DS Intelligence Data As A Service driver</td></tr></p><p><tr><td>SIGDEM</td><td>Scaled Integer Gridded DEM .sigdem</td></tr></p><p><tr><td>TGA</td><td>TGA/TARGA Image File Format</td></tr></p><p><tr><td>OGCAPI</td><td>OGCAPI</td></tr></p><p><tr><td>STACTA</td><td>Spatio-Temporal Asset Catalog Tiled Assets</td></tr></p><p><tr><td>STACIT</td><td>Spatio-Temporal Asset Catalog Items</td></tr></p><p><tr><td>GNMFile</td><td>Geographic Network generic file based model</td></tr></p><p><tr><td>GNMDatabase</td><td>Geographic Network generic DB based model</td></tr></p><p><tr><td>ESRI Shapefile</td><td>ESRI Shapefile</td></tr></p><p><tr><td>MapInfo File</td><td>MapInfo File</td></tr></p><p><tr><td>UK .NTF</td><td>UK .NTF</td></tr></p><p><tr><td>LVBAG</td><td>Kadaster LV BAG Extract 2.0</td></tr></p><p><tr><td>OGR_SDTS</td><td>SDTS</td></tr></p><p><tr><td>S57</td><td>IHO S-57 (ENC)</td></tr></p><p><tr><td>DGN</td><td>Microstation DGN</td></tr></p><p><tr><td>OGR_VRT</td><td>VRT - Virtual Datasource</td></tr></p><p><tr><td>Memory</td><td>Memory</td></tr></p><p><tr><td>CSV</td><td>Comma Separated Value (.csv)</td></tr></p><p><tr><td>NAS</td><td>NAS - ALKIS</td></tr></p><p><tr><td>GML</td><td>Geography Markup Language (GML)</td></tr></p><p><tr><td>GPX</td><td>GPX</td></tr></p><p><tr><td>LIBKML</td><td>Keyhole Markup Language (LIBKML)</td></tr></p><p><tr><td>KML</td><td>Keyhole Markup Language (KML)</td></tr></p><p><tr><td>GeoJSON</td><td>GeoJSON</td></tr></p><p><tr><td>GeoJSONSeq</td><td>GeoJSON Sequence</td></tr></p><p><tr><td>ESRIJSON</td><td>ESRIJSON</td></tr></p><p><tr><td>TopoJSON</td><td>TopoJSON</td></tr></p><p><tr><td>Interlis 1</td><td>Interlis 1</td></tr></p><p><tr><td>Interlis 2</td><td>Interlis 2</td></tr></p><p><tr><td>OGR_GMT</td><td>GMT ASCII Vectors (.gmt)</td></tr></p><p><tr><td>GPKG</td><td>GeoPackage</td></tr></p><p><tr><td>SQLite</td><td>SQLite / Spatialite</td></tr></p><p><tr><td>WAsP</td><td>WAsP .map format</td></tr></p><p><tr><td>PGeo</td><td>ESRI Personal GeoDatabase</td></tr></p><p><tr><td>OGR_OGDI</td><td>OGDI Vectors (VPF, VMAP, DCW)</td></tr></p><p><tr><td>PostgreSQL</td><td>PostgreSQL/PostGIS</td></tr></p><p><tr><td>MySQL</td><td>MySQL</td></tr></p><p><tr><td>OpenFileGDB</td><td>ESRI FileGDB</td></tr></p><p><tr><td>DXF</td><td>AutoCAD DXF</td></tr></p><p><tr><td>CAD</td><td>AutoCAD Driver</td></tr></p><p><tr><td>FlatGeobuf</td><td>FlatGeobuf</td></tr></p><p><tr><td>Geoconcept</td><td>Geoconcept</td></tr></p><p><tr><td>GeoRSS</td><td>GeoRSS</td></tr></p><p><tr><td>VFK</td><td>Czech Cadastral Exchange Data Format</td></tr></p><p><tr><td>PGDUMP</td><td>PostgreSQL SQL dump</td></tr></p><p><tr><td>OSM</td><td>OpenStreetMap XML and PBF</td></tr></p><p><tr><td>GPSBabel</td><td>GPSBabel</td></tr></p><p><tr><td>OGR_PDS</td><td>Planetary Data Systems TABLE</td></tr></p><p><tr><td>WFS</td><td>OGC WFS (Web Feature Service)</td></tr></p><p><tr><td>OAPIF</td><td>OGC API - Features</td></tr></p><p><tr><td>EDIGEO</td><td>French EDIGEO exchange format</td></tr></p><p><tr><td>SVG</td><td>Scalable Vector Graphics</td></tr></p><p><tr><td>Idrisi</td><td>Idrisi Vector (.vct)</td></tr></p><p><tr><td>XLS</td><td>MS Excel format</td></tr></p><p><tr><td>ODS</td><td>Open Document/ LibreOffice / OpenOffice Spreadsheet </td></tr></p><p><tr><td>XLSX</td><td>MS Office Open XML spreadsheet</td></tr></p><p><tr><td>Elasticsearch</td><td>Elastic Search</td></tr></p><p><tr><td>Carto</td><td>Carto</td></tr></p><p><tr><td>AmigoCloud</td><td>AmigoCloud</td></tr></p><p><tr><td>SXF</td><td>Storage and eXchange Format</td></tr></p><p><tr><td>Selafin</td><td>Selafin</td></tr></p><p><tr><td>JML</td><td>OpenJUMP JML</td></tr></p><p><tr><td>PLSCENES</td><td>Planet Labs Scenes API</td></tr></p><p><tr><td>CSW</td><td>OGC CSW (Catalog  Service for the Web)</td></tr></p><p><tr><td>VDV</td><td>VDV-451/VDV-452/INTREST Data Format</td></tr></p><p><tr><td>GMLAS</td><td>Geography Markup Language (GML) driven by application schemas</td></tr></p><p><tr><td>MVT</td><td>Mapbox Vector Tiles</td></tr></p><p><tr><td>NGW</td><td>NextGIS Web</td></tr></p><p><tr><td>MapML</td><td>MapML</td></tr></p><p><tr><td>TIGER</td><td>U.S. Census TIGER/Line</td></tr></p><p><tr><td>AVCBin</td><td>Arc/Info Binary Coverage</td></tr></p><p><tr><td>AVCE00</td><td>Arc/Info E00 (ASCII) Coverage</td></tr></p><p><tr><td>GenBin</td><td>Generic Binary (.hdr Labelled)</td></tr></p><p><tr><td>ENVI</td><td>ENVI .hdr Labelled</td></tr></p><p><tr><td>EHdr</td><td>ESRI .hdr Labelled</td></tr></p><p><tr><td>ISCE</td><td>ISCE raster</td></tr></p><p><tr><td>Zarr</td><td>Zarr</td></tr></p><p><tr><td>HTTP</td><td>HTTP Fetching Wrapper</td></tr></p><p></table><p><hr><span STYLE=\"font-style:italic;font-size:9pt;font-weight:bold\">SAGA - System for Automated Geoscientific Analyses<br></span><span STYLE=\"font-style:italic;font-size:8pt\">www.saga-gis.org<br></span><span STYLE=\"font-style:italic;font-size:6pt\">_____<br>Reference:<br>Conrad, O., Bechtel, B., Bock, M., Dietrich, H., Fischer, E., Gerlitz, L., Wehberg, J., Wichmann, V., and B__hner, J. (2015): System for Automated Geoscientific Analyses (SAGA) v. 2.1.4, Geosci. Model Dev., 8, 1991-2007, doi:10.5194/gmd-8-1991-2015.</span></p></p>"
		self.canRunInBackground = False

	def getParameterInfo(self):
		param = arcpy.Parameter(displayName="Raster Catalogue", name="CATALOGUE", direction="Output", parameterType="Required", datatype="GPFeatureLayer")
		params  = [param]
		param = arcpy.Parameter(displayName="Files", name="FILES", direction="Input", parameterType="Optional", datatype="DEFile", multiValue=True)
		params += [param]
		return params

	def execute(self, parameters, messages):
		Tool = ArcSAGA.SAGA_Tool('io_gdal', '7')
		Tool.Set_Output('CATALOGUE', parameters[0].valueAsText, 'shapes')
		Tool.Set_Option('FILES', parameters[1].valueAsText)
		Tool.Run()
		return


class tool_8(object):
	def __init__(self):
		self.label = "Create Raster Catalogues from Directory"
		self.description = "<p>Creates raster catalogues from all raster files found in the selected directory. Catalogues are split according to the coordinate reference system used by the different raster files. Output are polygon layers that show the extent for each raster file in it. Each extent is attributed with the original file path and raster system properties.</p><p></p><p>The \"GDAL Raster Import\" tool imports grid data from various file formats using the \"Geospatial Data Abstraction Library\" (GDAL) by Frank Warmerdam. For more information have a look at the GDAL homepage:</p><p>  <a target=\"_blank\" href=\"http://www.gdal.org/\">  http://www.gdal.org</a></p><p></p><p>GDAL Version:3.6.2</p><p></p><p>Following raster formats are currently supported:</p><p><table border=\"1\"><tr><th>ID</th><th>Name</th></tr></p><p><tr><td>ECW</td><td>ERDAS Compressed Wavelets (SDK 5.5)</td></tr></p><p><tr><td>JP2ECW</td><td>ERDAS JPEG2000 (SDK 5.5)</td></tr></p><p><tr><td>FITS</td><td>Flexible Image Transport System</td></tr></p><p><tr><td>HDF4</td><td>Hierarchical Data Format Release 4</td></tr></p><p><tr><td>HDF4Image</td><td>HDF4 Dataset</td></tr></p><p><tr><td>HDF5</td><td>Hierarchical Data Format Release 5</td></tr></p><p><tr><td>HDF5Image</td><td>HDF5 Dataset</td></tr></p><p><tr><td>BAG</td><td>Bathymetry Attributed Grid</td></tr></p><p><tr><td>KEA</td><td>KEA Image Format (.kea)</td></tr></p><p><tr><td>netCDF</td><td>Network Common Data Format</td></tr></p><p><tr><td>PDF</td><td>Geospatial PDF</td></tr></p><p><tr><td>FileGDB</td><td>ESRI FileGDB</td></tr></p><p><tr><td>ODBC</td><td></td></tr></p><p><tr><td>VRT</td><td>Virtual Raster</td></tr></p><p><tr><td>DERIVED</td><td>Derived datasets using VRT pixel functions</td></tr></p><p><tr><td>GTiff</td><td>GeoTIFF</td></tr></p><p><tr><td>COG</td><td>Cloud optimized GeoTIFF generator</td></tr></p><p><tr><td>NITF</td><td>National Imagery Transmission Format</td></tr></p><p><tr><td>RPFTOC</td><td>Raster Product Format TOC format</td></tr></p><p><tr><td>ECRGTOC</td><td>ECRG TOC format</td></tr></p><p><tr><td>HFA</td><td>Erdas Imagine Images (.img)</td></tr></p><p><tr><td>SAR_CEOS</td><td>CEOS SAR Image</td></tr></p><p><tr><td>CEOS</td><td>CEOS Image</td></tr></p><p><tr><td>JAXAPALSAR</td><td>JAXA PALSAR Product Reader (Level 1.1/1.5)</td></tr></p><p><tr><td>GFF</td><td>Ground-based SAR Applications Testbed File Format (.gff)</td></tr></p><p><tr><td>ELAS</td><td>ELAS</td></tr></p><p><tr><td>ESRIC</td><td>Esri Compact Cache</td></tr></p><p><tr><td>AIG</td><td>Arc/Info Binary Grid</td></tr></p><p><tr><td>AAIGrid</td><td>Arc/Info ASCII Grid</td></tr></p><p><tr><td>GRASSASCIIGrid</td><td>GRASS ASCII Grid</td></tr></p><p><tr><td>ISG</td><td>International Service for the Geoid</td></tr></p><p><tr><td>SDTS</td><td>SDTS Raster</td></tr></p><p><tr><td>DTED</td><td>DTED Elevation Raster</td></tr></p><p><tr><td>PNG</td><td>Portable Network Graphics</td></tr></p><p><tr><td>JPEG</td><td>JPEG JFIF</td></tr></p><p><tr><td>MEM</td><td>In Memory Raster</td></tr></p><p><tr><td>JDEM</td><td>Japanese DEM (.mem)</td></tr></p><p><tr><td>GIF</td><td>Graphics Interchange Format (.gif)</td></tr></p><p><tr><td>BIGGIF</td><td>Graphics Interchange Format (.gif)</td></tr></p><p><tr><td>ESAT</td><td>Envisat Image Format</td></tr></p><p><tr><td>BSB</td><td>Maptech BSB Nautical Charts</td></tr></p><p><tr><td>XPM</td><td>X11 PixMap Format</td></tr></p><p><tr><td>BMP</td><td>MS Windows Device Independent Bitmap</td></tr></p><p><tr><td>DIMAP</td><td>SPOT DIMAP</td></tr></p><p><tr><td>AirSAR</td><td>AirSAR Polarimetric Image</td></tr></p><p><tr><td>RS2</td><td>RadarSat 2 XML Product</td></tr></p><p><tr><td>SAFE</td><td>Sentinel-1 SAR SAFE Product</td></tr></p><p><tr><td>PCIDSK</td><td>PCIDSK Database File</td></tr></p><p><tr><td>PCRaster</td><td>PCRaster Raster File</td></tr></p><p><tr><td>ILWIS</td><td>ILWIS Raster Map</td></tr></p><p><tr><td>SGI</td><td>SGI Image File Format 1.0</td></tr></p><p><tr><td>SRTMHGT</td><td>SRTMHGT File Format</td></tr></p><p><tr><td>Leveller</td><td>Leveller heightfield</td></tr></p><p><tr><td>Terragen</td><td>Terragen heightfield</td></tr></p><p><tr><td>ISIS3</td><td>USGS Astrogeology ISIS cube (Version 3)</td></tr></p><p><tr><td>ISIS2</td><td>USGS Astrogeology ISIS cube (Version 2)</td></tr></p><p><tr><td>PDS</td><td>NASA Planetary Data System</td></tr></p><p><tr><td>PDS4</td><td>NASA Planetary Data System 4</td></tr></p><p><tr><td>VICAR</td><td>MIPL VICAR file</td></tr></p><p><tr><td>TIL</td><td>EarthWatch .TIL</td></tr></p><p><tr><td>ERS</td><td>ERMapper .ers Labelled</td></tr></p><p><tr><td>JP2OpenJPEG</td><td>JPEG-2000 driver based on OpenJPEG library</td></tr></p><p><tr><td>L1B</td><td>NOAA Polar Orbiter Level 1b Data Set</td></tr></p><p><tr><td>FIT</td><td>FIT Image</td></tr></p><p><tr><td>GRIB</td><td>GRIdded Binary (.grb, .grb2)</td></tr></p><p><tr><td>RMF</td><td>Raster Matrix Format</td></tr></p><p><tr><td>WCS</td><td>OGC Web Coverage Service</td></tr></p><p><tr><td>WMS</td><td>OGC Web Map Service</td></tr></p><p><tr><td>MSGN</td><td>EUMETSAT Archive native (.nat)</td></tr></p><p><tr><td>RST</td><td>Idrisi Raster A.1</td></tr></p><p><tr><td>GSAG</td><td>Golden Software ASCII Grid (.grd)</td></tr></p><p><tr><td>GSBG</td><td>Golden Software Binary Grid (.grd)</td></tr></p><p><tr><td>GS7BG</td><td>Golden Software 7 Binary Grid (.grd)</td></tr></p><p><tr><td>COSAR</td><td>COSAR Annotated Binary Matrix (TerraSAR-X)</td></tr></p><p><tr><td>TSX</td><td>TerraSAR-X Product</td></tr></p><p><tr><td>COASP</td><td>DRDC COASP SAR Processor Raster</td></tr></p><p><tr><td>R</td><td>R Object Data Store</td></tr></p><p><tr><td>MAP</td><td>OziExplorer .MAP</td></tr></p><p><tr><td>KMLSUPEROVERLAY</td><td>Kml Super Overlay</td></tr></p><p><tr><td>WEBP</td><td>WEBP</td></tr></p><p><tr><td>Rasterlite</td><td>Rasterlite</td></tr></p><p><tr><td>MBTiles</td><td>MBTiles</td></tr></p><p><tr><td>PLMOSAIC</td><td>Planet Labs Mosaics API</td></tr></p><p><tr><td>CALS</td><td>CALS (Type 1)</td></tr></p><p><tr><td>WMTS</td><td>OGC Web Map Tile Service</td></tr></p><p><tr><td>SENTINEL2</td><td>Sentinel 2</td></tr></p><p><tr><td>MRF</td><td>Meta Raster Format</td></tr></p><p><tr><td>PNM</td><td>Portable Pixmap Format (netpbm)</td></tr></p><p><tr><td>DOQ1</td><td>USGS DOQ (Old Style)</td></tr></p><p><tr><td>DOQ2</td><td>USGS DOQ (New Style)</td></tr></p><p><tr><td>PAux</td><td>PCI .aux Labelled</td></tr></p><p><tr><td>MFF</td><td>Vexcel MFF Raster</td></tr></p><p><tr><td>MFF2</td><td>Vexcel MFF2 (HKV) Raster</td></tr></p><p><tr><td>GSC</td><td>GSC Geogrid</td></tr></p><p><tr><td>FAST</td><td>EOSAT FAST Format</td></tr></p><p><tr><td>BT</td><td>VTP .bt (Binary Terrain) 1.3 Format</td></tr></p><p><tr><td>LAN</td><td>Erdas .LAN/.GIS</td></tr></p><p><tr><td>CPG</td><td>Convair PolGASP</td></tr></p><p><tr><td>NDF</td><td>NLAPS Data Format</td></tr></p><p><tr><td>EIR</td><td>Erdas Imagine Raw</td></tr></p><p><tr><td>DIPEx</td><td>DIPEx</td></tr></p><p><tr><td>LCP</td><td>FARSITE v.4 Landscape File (.lcp)</td></tr></p><p><tr><td>GTX</td><td>NOAA Vertical Datum .GTX</td></tr></p><p><tr><td>LOSLAS</td><td>NADCON .los/.las Datum Grid Shift</td></tr></p><p><tr><td>NTv2</td><td>NTv2 Datum Grid Shift</td></tr></p><p><tr><td>CTable2</td><td>CTable2 Datum Grid Shift</td></tr></p><p><tr><td>ACE2</td><td>ACE2</td></tr></p><p><tr><td>SNODAS</td><td>Snow Data Assimilation System</td></tr></p><p><tr><td>KRO</td><td>KOLOR Raw</td></tr></p><p><tr><td>ROI_PAC</td><td>ROI_PAC raster</td></tr></p><p><tr><td>RRASTER</td><td>R Raster</td></tr></p><p><tr><td>BYN</td><td>Natural Resources Canada's Geoid</td></tr></p><p><tr><td>ARG</td><td>Azavea Raster Grid format</td></tr></p><p><tr><td>RIK</td><td>Swedish Grid RIK (.rik)</td></tr></p><p><tr><td>USGSDEM</td><td>USGS Optional ASCII DEM (and CDED)</td></tr></p><p><tr><td>GXF</td><td>GeoSoft Grid Exchange Format</td></tr></p><p><tr><td>NWT_GRD</td><td>Northwood Numeric Grid Format .grd/.tab</td></tr></p><p><tr><td>NWT_GRC</td><td>Northwood Classified Grid Format .grc/.tab</td></tr></p><p><tr><td>ADRG</td><td>ARC Digitized Raster Graphics</td></tr></p><p><tr><td>SRP</td><td>Standard Raster Product (ASRP/USRP)</td></tr></p><p><tr><td>BLX</td><td>Magellan topo (.blx)</td></tr></p><p><tr><td>PostGISRaster</td><td>PostGIS Raster driver</td></tr></p><p><tr><td>SAGA</td><td>SAGA GIS Binary Grid (.sdat, .sg-grd-z)</td></tr></p><p><tr><td>XYZ</td><td>ASCII Gridded XYZ</td></tr></p><p><tr><td>HF2</td><td>HF2/HFZ heightfield raster</td></tr></p><p><tr><td>OZI</td><td>OziExplorer Image File</td></tr></p><p><tr><td>CTG</td><td>USGS LULC Composite Theme Grid</td></tr></p><p><tr><td>ZMap</td><td>ZMap Plus Grid</td></tr></p><p><tr><td>NGSGEOID</td><td>NOAA NGS Geoid Height Grids</td></tr></p><p><tr><td>IRIS</td><td>IRIS data (.PPI, .CAPPi etc)</td></tr></p><p><tr><td>PRF</td><td>Racurs PHOTOMOD PRF</td></tr></p><p><tr><td>EEDAI</td><td>Earth Engine Data API Image</td></tr></p><p><tr><td>EEDA</td><td>Earth Engine Data API</td></tr></p><p><tr><td>DAAS</td><td>Airbus DS Intelligence Data As A Service driver</td></tr></p><p><tr><td>SIGDEM</td><td>Scaled Integer Gridded DEM .sigdem</td></tr></p><p><tr><td>TGA</td><td>TGA/TARGA Image File Format</td></tr></p><p><tr><td>OGCAPI</td><td>OGCAPI</td></tr></p><p><tr><td>STACTA</td><td>Spatio-Temporal Asset Catalog Tiled Assets</td></tr></p><p><tr><td>STACIT</td><td>Spatio-Temporal Asset Catalog Items</td></tr></p><p><tr><td>GNMFile</td><td>Geographic Network generic file based model</td></tr></p><p><tr><td>GNMDatabase</td><td>Geographic Network generic DB based model</td></tr></p><p><tr><td>ESRI Shapefile</td><td>ESRI Shapefile</td></tr></p><p><tr><td>MapInfo File</td><td>MapInfo File</td></tr></p><p><tr><td>UK .NTF</td><td>UK .NTF</td></tr></p><p><tr><td>LVBAG</td><td>Kadaster LV BAG Extract 2.0</td></tr></p><p><tr><td>OGR_SDTS</td><td>SDTS</td></tr></p><p><tr><td>S57</td><td>IHO S-57 (ENC)</td></tr></p><p><tr><td>DGN</td><td>Microstation DGN</td></tr></p><p><tr><td>OGR_VRT</td><td>VRT - Virtual Datasource</td></tr></p><p><tr><td>Memory</td><td>Memory</td></tr></p><p><tr><td>CSV</td><td>Comma Separated Value (.csv)</td></tr></p><p><tr><td>NAS</td><td>NAS - ALKIS</td></tr></p><p><tr><td>GML</td><td>Geography Markup Language (GML)</td></tr></p><p><tr><td>GPX</td><td>GPX</td></tr></p><p><tr><td>LIBKML</td><td>Keyhole Markup Language (LIBKML)</td></tr></p><p><tr><td>KML</td><td>Keyhole Markup Language (KML)</td></tr></p><p><tr><td>GeoJSON</td><td>GeoJSON</td></tr></p><p><tr><td>GeoJSONSeq</td><td>GeoJSON Sequence</td></tr></p><p><tr><td>ESRIJSON</td><td>ESRIJSON</td></tr></p><p><tr><td>TopoJSON</td><td>TopoJSON</td></tr></p><p><tr><td>Interlis 1</td><td>Interlis 1</td></tr></p><p><tr><td>Interlis 2</td><td>Interlis 2</td></tr></p><p><tr><td>OGR_GMT</td><td>GMT ASCII Vectors (.gmt)</td></tr></p><p><tr><td>GPKG</td><td>GeoPackage</td></tr></p><p><tr><td>SQLite</td><td>SQLite / Spatialite</td></tr></p><p><tr><td>WAsP</td><td>WAsP .map format</td></tr></p><p><tr><td>PGeo</td><td>ESRI Personal GeoDatabase</td></tr></p><p><tr><td>OGR_OGDI</td><td>OGDI Vectors (VPF, VMAP, DCW)</td></tr></p><p><tr><td>PostgreSQL</td><td>PostgreSQL/PostGIS</td></tr></p><p><tr><td>MySQL</td><td>MySQL</td></tr></p><p><tr><td>OpenFileGDB</td><td>ESRI FileGDB</td></tr></p><p><tr><td>DXF</td><td>AutoCAD DXF</td></tr></p><p><tr><td>CAD</td><td>AutoCAD Driver</td></tr></p><p><tr><td>FlatGeobuf</td><td>FlatGeobuf</td></tr></p><p><tr><td>Geoconcept</td><td>Geoconcept</td></tr></p><p><tr><td>GeoRSS</td><td>GeoRSS</td></tr></p><p><tr><td>VFK</td><td>Czech Cadastral Exchange Data Format</td></tr></p><p><tr><td>PGDUMP</td><td>PostgreSQL SQL dump</td></tr></p><p><tr><td>OSM</td><td>OpenStreetMap XML and PBF</td></tr></p><p><tr><td>GPSBabel</td><td>GPSBabel</td></tr></p><p><tr><td>OGR_PDS</td><td>Planetary Data Systems TABLE</td></tr></p><p><tr><td>WFS</td><td>OGC WFS (Web Feature Service)</td></tr></p><p><tr><td>OAPIF</td><td>OGC API - Features</td></tr></p><p><tr><td>EDIGEO</td><td>French EDIGEO exchange format</td></tr></p><p><tr><td>SVG</td><td>Scalable Vector Graphics</td></tr></p><p><tr><td>Idrisi</td><td>Idrisi Vector (.vct)</td></tr></p><p><tr><td>XLS</td><td>MS Excel format</td></tr></p><p><tr><td>ODS</td><td>Open Document/ LibreOffice / OpenOffice Spreadsheet </td></tr></p><p><tr><td>XLSX</td><td>MS Office Open XML spreadsheet</td></tr></p><p><tr><td>Elasticsearch</td><td>Elastic Search</td></tr></p><p><tr><td>Carto</td><td>Carto</td></tr></p><p><tr><td>AmigoCloud</td><td>AmigoCloud</td></tr></p><p><tr><td>SXF</td><td>Storage and eXchange Format</td></tr></p><p><tr><td>Selafin</td><td>Selafin</td></tr></p><p><tr><td>JML</td><td>OpenJUMP JML</td></tr></p><p><tr><td>PLSCENES</td><td>Planet Labs Scenes API</td></tr></p><p><tr><td>CSW</td><td>OGC CSW (Catalog  Service for the Web)</td></tr></p><p><tr><td>VDV</td><td>VDV-451/VDV-452/INTREST Data Format</td></tr></p><p><tr><td>GMLAS</td><td>Geography Markup Language (GML) driven by application schemas</td></tr></p><p><tr><td>MVT</td><td>Mapbox Vector Tiles</td></tr></p><p><tr><td>NGW</td><td>NextGIS Web</td></tr></p><p><tr><td>MapML</td><td>MapML</td></tr></p><p><tr><td>TIGER</td><td>U.S. Census TIGER/Line</td></tr></p><p><tr><td>AVCBin</td><td>Arc/Info Binary Coverage</td></tr></p><p><tr><td>AVCE00</td><td>Arc/Info E00 (ASCII) Coverage</td></tr></p><p><tr><td>GenBin</td><td>Generic Binary (.hdr Labelled)</td></tr></p><p><tr><td>ENVI</td><td>ENVI .hdr Labelled</td></tr></p><p><tr><td>EHdr</td><td>ESRI .hdr Labelled</td></tr></p><p><tr><td>ISCE</td><td>ISCE raster</td></tr></p><p><tr><td>Zarr</td><td>Zarr</td></tr></p><p><tr><td>HTTP</td><td>HTTP Fetching Wrapper</td></tr></p><p></table><p><hr><span STYLE=\"font-style:italic;font-size:9pt;font-weight:bold\">SAGA - System for Automated Geoscientific Analyses<br></span><span STYLE=\"font-style:italic;font-size:8pt\">www.saga-gis.org<br></span><span STYLE=\"font-style:italic;font-size:6pt\">_____<br>Reference:<br>Conrad, O., Bechtel, B., Bock, M., Dietrich, H., Fischer, E., Gerlitz, L., Wehberg, J., Wichmann, V., and B__hner, J. (2015): System for Automated Geoscientific Analyses (SAGA) v. 2.1.4, Geosci. Model Dev., 8, 1991-2007, doi:10.5194/gmd-8-1991-2015.</span></p></p>"
		self.canRunInBackground = False

	def getParameterInfo(self):
		param = arcpy.Parameter(displayName="Raster Catalogues", name="CATALOGUES", direction="Output", parameterType="Required", datatype="GPFeatureLayer", multiValue=True)
		params  = [param]
		param = arcpy.Parameter(displayName="Raster Catalogue", name="CATALOGUE_GCS", direction="Output", parameterType="Required", datatype="GPFeatureLayer")
		params += [param]
		param = arcpy.Parameter(displayName="Raster Catalogue (unknown CRS)", name="CATALOGUE_UKN", direction="Output", parameterType="Optional", datatype="GPFeatureLayer")
		params += [param]
		param = arcpy.Parameter(displayName="Directory", name="DIRECTORY", direction="Input", parameterType="Optional", datatype="DEFolder")
		params += [param]
		param = arcpy.Parameter(displayName="Extensions", name="EXTENSIONS", direction="Input", parameterType="Optional", datatype="GPString")
		param.value = "sgrd; tif"
		params += [param]
		param = arcpy.Parameter(displayName="Output", name="OUTPUT", direction="Input", parameterType="Optional", datatype="GPString")
		param.filter.list = ["one catalogue for each coordinate system", "one catalogue using geographic coordinates"]
		param.value = "one catalogue using geographic coordinates"
		params += [param]
		return params

	def execute(self, parameters, messages):
		Tool = ArcSAGA.SAGA_Tool('io_gdal', '8')
		Tool.Set_Output('CATALOGUES', parameters[0].valueAsText, 'shapes_list')
		Tool.Set_Output('CATALOGUE_GCS', parameters[1].valueAsText, 'shapes')
		Tool.Set_Output('CATALOGUE_UKN', parameters[2].valueAsText, 'shapes')
		Tool.Set_Option('DIRECTORY', parameters[3].valueAsText)
		Tool.Set_Option('EXTENSIONS', parameters[4].valueAsText)
		Tool.Set_Option('OUTPUT', parameters[5].valueAsText)
		Tool.Run()
		return


class tool_10(object):
	def __init__(self):
		self.label = "GDAL Formats"
		self.description = "<p>This tool lists all (file) formats supported by the currently loaded GDAL library. </p><p>GDAL Version:3.6.2</p><p></p><p><p><hr><span STYLE=\"font-style:italic;font-size:9pt;font-weight:bold\">SAGA - System for Automated Geoscientific Analyses<br></span><span STYLE=\"font-style:italic;font-size:8pt\">www.saga-gis.org<br></span><span STYLE=\"font-style:italic;font-size:6pt\">_____<br>Reference:<br>Conrad, O., Bechtel, B., Bock, M., Dietrich, H., Fischer, E., Gerlitz, L., Wehberg, J., Wichmann, V., and B__hner, J. (2015): System for Automated Geoscientific Analyses (SAGA) v. 2.1.4, Geosci. Model Dev., 8, 1991-2007, doi:10.5194/gmd-8-1991-2015.</span></p></p>"
		self.canRunInBackground = False

	def getParameterInfo(self):
		param = arcpy.Parameter(displayName="GDAL Formats", name="FORMATS", direction="Output", parameterType="Required", datatype="GPTableView")
		params  = [param]
		param = arcpy.Parameter(displayName="Type", name="TYPE", direction="Input", parameterType="Optional", datatype="GPString")
		param.filter.list = ["raster", "vector", "all"]
		param.value = "all"
		params += [param]
		param = arcpy.Parameter(displayName="Access", name="ACCESS", direction="Input", parameterType="Optional", datatype="GPString")
		param.filter.list = ["read", "write", "read or write"]
		param.value = "read or write"
		params += [param]
		param = arcpy.Parameter(displayName="All Recognized Files", name="RECOGNIZED", direction="Input", parameterType="Optional", datatype="GPBoolean")
		param.value = True
		params += [param]
		return params

	def execute(self, parameters, messages):
		Tool = ArcSAGA.SAGA_Tool('io_gdal', '10')
		Tool.Set_Output('FORMATS', parameters[0].valueAsText, 'table')
		Tool.Set_Option('TYPE', parameters[1].valueAsText)
		Tool.Set_Option('ACCESS', parameters[2].valueAsText)
		Tool.Set_Option('RECOGNIZED', parameters[3].valueAsText)
		Tool.Run()
		return


class tool_12(object):
	def __init__(self):
		self.label = "Create Virtual Raster (VRT)"
		self.description = "<p>The tool allows one to create a virtual dataset (VRT) which is a mosaic of the input raster datasets. Such a VRT can be used for seamless data access to a large number of raster tiles, a typical application is the clipping of raster tiles from such a VRT.</p><p></p><p></p><p>GDAL Version:3.6.2</p><p></p><p>Following raster formats are currently supported:</p><p><table border=\"1\"><tr><th>ID</th><th>Name</th><th>Extension</th></tr><tr><td>ECW</td><td>ERDAS Compressed Wavelets (SDK 5.5)</td><td>ecw</td></tr><tr><td>JP2ECW</td><td>ERDAS JPEG2000 (SDK 5.5)</td><td>jp2</td></tr><tr><td>FITS</td><td>Flexible Image Transport System</td><td></td></tr><tr><td>HDF4</td><td>Hierarchical Data Format Release 4</td><td>hdf</td></tr><tr><td>HDF4Image</td><td>HDF4 Dataset</td><td></td></tr><tr><td>HDF5</td><td>Hierarchical Data Format Release 5</td><td></td></tr><tr><td>HDF5Image</td><td>HDF5 Dataset</td><td></td></tr><tr><td>BAG</td><td>Bathymetry Attributed Grid</td><td>bag</td></tr><tr><td>KEA</td><td>KEA Image Format (.kea)</td><td>kea</td></tr><tr><td>netCDF</td><td>Network Common Data Format</td><td>nc</td></tr><tr><td>PDF</td><td>Geospatial PDF</td><td>pdf</td></tr><tr><td>VRT</td><td>Virtual Raster</td><td>vrt</td></tr><tr><td>DERIVED</td><td>Derived datasets using VRT pixel functions</td><td></td></tr><tr><td>GTiff</td><td>GeoTIFF</td><td>tif</td></tr><tr><td>NITF</td><td>National Imagery Transmission Format</td><td>ntf</td></tr><tr><td>RPFTOC</td><td>Raster Product Format TOC format</td><td>toc</td></tr><tr><td>ECRGTOC</td><td>ECRG TOC format</td><td>xml</td></tr><tr><td>HFA</td><td>Erdas Imagine Images (.img)</td><td>img</td></tr><tr><td>SAR_CEOS</td><td>CEOS SAR Image</td><td></td></tr><tr><td>CEOS</td><td>CEOS Image</td><td></td></tr><tr><td>JAXAPALSAR</td><td>JAXA PALSAR Product Reader (Level 1.1/1.5)</td><td></td></tr><tr><td>GFF</td><td>Ground-based SAR Applications Testbed File Format (.gff)</td><td>gff</td></tr><tr><td>ELAS</td><td>ELAS</td><td></td></tr><tr><td>ESRIC</td><td>Esri Compact Cache</td><td></td></tr><tr><td>AIG</td><td>Arc/Info Binary Grid</td><td></td></tr><tr><td>AAIGrid</td><td>Arc/Info ASCII Grid</td><td>asc</td></tr><tr><td>GRASSASCIIGrid</td><td>GRASS ASCII Grid</td><td></td></tr><tr><td>ISG</td><td>International Service for the Geoid</td><td>isg</td></tr><tr><td>SDTS</td><td>SDTS Raster</td><td>ddf</td></tr><tr><td>DTED</td><td>DTED Elevation Raster</td><td></td></tr><tr><td>PNG</td><td>Portable Network Graphics</td><td>png</td></tr><tr><td>JPEG</td><td>JPEG JFIF</td><td>jpg</td></tr><tr><td>MEM</td><td>In Memory Raster</td><td></td></tr><tr><td>JDEM</td><td>Japanese DEM (.mem)</td><td>mem</td></tr><tr><td>GIF</td><td>Graphics Interchange Format (.gif)</td><td>gif</td></tr><tr><td>BIGGIF</td><td>Graphics Interchange Format (.gif)</td><td>gif</td></tr><tr><td>ESAT</td><td>Envisat Image Format</td><td>n1</td></tr><tr><td>BSB</td><td>Maptech BSB Nautical Charts</td><td>kap</td></tr><tr><td>XPM</td><td>X11 PixMap Format</td><td>xpm</td></tr><tr><td>BMP</td><td>MS Windows Device Independent Bitmap</td><td>bmp</td></tr><tr><td>DIMAP</td><td>SPOT DIMAP</td><td></td></tr><tr><td>AirSAR</td><td>AirSAR Polarimetric Image</td><td></td></tr><tr><td>RS2</td><td>RadarSat 2 XML Product</td><td></td></tr><tr><td>SAFE</td><td>Sentinel-1 SAR SAFE Product</td><td></td></tr><tr><td>PCIDSK</td><td>PCIDSK Database File</td><td>pix</td></tr><tr><td>PCRaster</td><td>PCRaster Raster File</td><td>map</td></tr><tr><td>ILWIS</td><td>ILWIS Raster Map</td><td></td></tr><tr><td>SGI</td><td>SGI Image File Format 1.0</td><td>rgb</td></tr><tr><td>SRTMHGT</td><td>SRTMHGT File Format</td><td>hgt</td></tr><tr><td>Leveller</td><td>Leveller heightfield</td><td>ter</td></tr><tr><td>Terragen</td><td>Terragen heightfield</td><td>ter</td></tr><tr><td>ISIS3</td><td>USGS Astrogeology ISIS cube (Version 3)</td><td></td></tr><tr><td>ISIS2</td><td>USGS Astrogeology ISIS cube (Version 2)</td><td></td></tr><tr><td>PDS</td><td>NASA Planetary Data System</td><td></td></tr><tr><td>PDS4</td><td>NASA Planetary Data System 4</td><td>xml</td></tr><tr><td>VICAR</td><td>MIPL VICAR file</td><td></td></tr><tr><td>TIL</td><td>EarthWatch .TIL</td><td></td></tr><tr><td>ERS</td><td>ERMapper .ers Labelled</td><td>ers</td></tr><tr><td>JP2OpenJPEG</td><td>JPEG-2000 driver based on OpenJPEG library</td><td>jp2</td></tr><tr><td>L1B</td><td>NOAA Polar Orbiter Level 1b Data Set</td><td></td></tr><tr><td>FIT</td><td>FIT Image</td><td></td></tr><tr><td>GRIB</td><td>GRIdded Binary (.grb, .grb2)</td><td></td></tr><tr><td>RMF</td><td>Raster Matrix Format</td><td>rsw</td></tr><tr><td>WCS</td><td>OGC Web Coverage Service</td><td></td></tr><tr><td>WMS</td><td>OGC Web Map Service</td><td></td></tr><tr><td>MSGN</td><td>EUMETSAT Archive native (.nat)</td><td>nat</td></tr><tr><td>RST</td><td>Idrisi Raster A.1</td><td>rst</td></tr><tr><td>GSAG</td><td>Golden Software ASCII Grid (.grd)</td><td>grd</td></tr><tr><td>GSBG</td><td>Golden Software Binary Grid (.grd)</td><td>grd</td></tr><tr><td>GS7BG</td><td>Golden Software 7 Binary Grid (.grd)</td><td>grd</td></tr><tr><td>COSAR</td><td>COSAR Annotated Binary Matrix (TerraSAR-X)</td><td></td></tr><tr><td>TSX</td><td>TerraSAR-X Product</td><td></td></tr><tr><td>COASP</td><td>DRDC COASP SAR Processor Raster</td><td>hdr</td></tr><tr><td>R</td><td>R Object Data Store</td><td>rda</td></tr><tr><td>MAP</td><td>OziExplorer .MAP</td><td></td></tr><tr><td>KMLSUPEROVERLAY</td><td>Kml Super Overlay</td><td></td></tr><tr><td>WEBP</td><td>WEBP</td><td>webp</td></tr><tr><td>Rasterlite</td><td>Rasterlite</td><td>sqlite</td></tr><tr><td>MBTiles</td><td>MBTiles</td><td>mbtiles</td></tr><tr><td>PLMOSAIC</td><td>Planet Labs Mosaics API</td><td></td></tr><tr><td>CALS</td><td>CALS (Type 1)</td><td></td></tr><tr><td>WMTS</td><td>OGC Web Map Tile Service</td><td></td></tr><tr><td>SENTINEL2</td><td>Sentinel 2</td><td></td></tr><tr><td>MRF</td><td>Meta Raster Format</td><td>mrf</td></tr><tr><td>PNM</td><td>Portable Pixmap Format (netpbm)</td><td></td></tr><tr><td>DOQ1</td><td>USGS DOQ (Old Style)</td><td></td></tr><tr><td>DOQ2</td><td>USGS DOQ (New Style)</td><td></td></tr><tr><td>PAux</td><td>PCI .aux Labelled</td><td></td></tr><tr><td>MFF</td><td>Vexcel MFF Raster</td><td>hdr</td></tr><tr><td>MFF2</td><td>Vexcel MFF2 (HKV) Raster</td><td></td></tr><tr><td>GSC</td><td>GSC Geogrid</td><td></td></tr><tr><td>FAST</td><td>EOSAT FAST Format</td><td></td></tr><tr><td>BT</td><td>VTP .bt (Binary Terrain) 1.3 Format</td><td>bt</td></tr><tr><td>LAN</td><td>Erdas .LAN/.GIS</td><td></td></tr><tr><td>CPG</td><td>Convair PolGASP</td><td></td></tr><tr><td>NDF</td><td>NLAPS Data Format</td><td></td></tr><tr><td>EIR</td><td>Erdas Imagine Raw</td><td></td></tr><tr><td>DIPEx</td><td>DIPEx</td><td></td></tr><tr><td>LCP</td><td>FARSITE v.4 Landscape File (.lcp)</td><td>lcp</td></tr><tr><td>GTX</td><td>NOAA Vertical Datum .GTX</td><td>gtx</td></tr><tr><td>LOSLAS</td><td>NADCON .los/.las Datum Grid Shift</td><td></td></tr><tr><td>NTv2</td><td>NTv2 Datum Grid Shift</td><td></td></tr><tr><td>CTable2</td><td>CTable2 Datum Grid Shift</td><td></td></tr><tr><td>ACE2</td><td>ACE2</td><td>ACE2</td></tr><tr><td>SNODAS</td><td>Snow Data Assimilation System</td><td>hdr</td></tr><tr><td>KRO</td><td>KOLOR Raw</td><td>kro</td></tr><tr><td>ROI_PAC</td><td>ROI_PAC raster</td><td></td></tr><tr><td>RRASTER</td><td>R Raster</td><td>grd</td></tr><tr><td>BYN</td><td>Natural Resources Canada's Geoid</td><td></td></tr><tr><td>ARG</td><td>Azavea Raster Grid format</td><td></td></tr><tr><td>RIK</td><td>Swedish Grid RIK (.rik)</td><td>rik</td></tr><tr><td>USGSDEM</td><td>USGS Optional ASCII DEM (and CDED)</td><td>dem</td></tr><tr><td>GXF</td><td>GeoSoft Grid Exchange Format</td><td>gxf</td></tr><tr><td>NWT_GRD</td><td>Northwood Numeric Grid Format .grd/.tab</td><td>grd</td></tr><tr><td>NWT_GRC</td><td>Northwood Classified Grid Format .grc/.tab</td><td>grc</td></tr><tr><td>ADRG</td><td>ARC Digitized Raster Graphics</td><td>gen</td></tr><tr><td>SRP</td><td>Standard Raster Product (ASRP/USRP)</td><td>img</td></tr><tr><td>BLX</td><td>Magellan topo (.blx)</td><td>blx</td></tr><tr><td>PostGISRaster</td><td>PostGIS Raster driver</td><td></td></tr><tr><td>SAGA</td><td>SAGA GIS Binary Grid (.sdat, .sg-grd-z)</td><td></td></tr><tr><td>XYZ</td><td>ASCII Gridded XYZ</td><td>xyz</td></tr><tr><td>HF2</td><td>HF2/HFZ heightfield raster</td><td>hf2</td></tr><tr><td>OZI</td><td>OziExplorer Image File</td><td></td></tr><tr><td>CTG</td><td>USGS LULC Composite Theme Grid</td><td></td></tr><tr><td>ZMap</td><td>ZMap Plus Grid</td><td>dat</td></tr><tr><td>NGSGEOID</td><td>NOAA NGS Geoid Height Grids</td><td>bin</td></tr><tr><td>IRIS</td><td>IRIS data (.PPI, .CAPPi etc)</td><td>ppi</td></tr><tr><td>PRF</td><td>Racurs PHOTOMOD PRF</td><td>prf</td></tr><tr><td>EEDAI</td><td>Earth Engine Data API Image</td><td></td></tr><tr><td>DAAS</td><td>Airbus DS Intelligence Data As A Service driver</td><td></td></tr><tr><td>SIGDEM</td><td>Scaled Integer Gridded DEM .sigdem</td><td>sigdem</td></tr><tr><td>TGA</td><td>TGA/TARGA Image File Format</td><td>tga</td></tr><tr><td>OGCAPI</td><td>OGCAPI</td><td></td></tr><tr><td>STACTA</td><td>Spatio-Temporal Asset Catalog Tiled Assets</td><td>json</td></tr><tr><td>STACIT</td><td>Spatio-Temporal Asset Catalog Items</td><td></td></tr><tr><td>GPKG</td><td>GeoPackage</td><td>gpkg</td></tr><tr><td>CAD</td><td>AutoCAD Driver</td><td>dwg</td></tr><tr><td>PLSCENES</td><td>Planet Labs Scenes API</td><td></td></tr><tr><td>NGW</td><td>NextGIS Web</td><td></td></tr><tr><td>GenBin</td><td>Generic Binary (.hdr Labelled)</td><td></td></tr><tr><td>ENVI</td><td>ENVI .hdr Labelled</td><td></td></tr><tr><td>EHdr</td><td>ESRI .hdr Labelled</td><td>bil</td></tr><tr><td>ISCE</td><td>ISCE raster</td><td></td></tr><tr><td>Zarr</td><td>Zarr</td><td></td></tr><tr><td>HTTP</td><td>HTTP Fetching Wrapper</td><td></td></tr></table><p><hr><span STYLE=\"font-style:italic;font-size:9pt;font-weight:bold\">SAGA - System for Automated Geoscientific Analyses<br></span><span STYLE=\"font-style:italic;font-size:8pt\">www.saga-gis.org<br></span><span STYLE=\"font-style:italic;font-size:6pt\">_____<br>Reference:<br>Conrad, O., Bechtel, B., Bock, M., Dietrich, H., Fischer, E., Gerlitz, L., Wehberg, J., Wichmann, V., and B__hner, J. (2015): System for Automated Geoscientific Analyses (SAGA) v. 2.1.4, Geosci. Model Dev., 8, 1991-2007, doi:10.5194/gmd-8-1991-2015.</span></p></p>"
		self.canRunInBackground = False

	def getParameterInfo(self):
		param = arcpy.Parameter(displayName="Files", name="FILES", direction="Input", parameterType="Optional", datatype="DEFile", multiValue=True)
		params  = [param]
		param = arcpy.Parameter(displayName="Input File List", name="FILE_LIST", direction="Input", parameterType="Optional", datatype="DEFile")
		params += [param]
		param = arcpy.Parameter(displayName="VRT Filename", name="VRT_NAME", direction="Input", parameterType="Optional", datatype="DEFile")
		params += [param]
		param = arcpy.Parameter(displayName="Resampling", name="RESAMPLING", direction="Input", parameterType="Optional", datatype="GPString")
		param.filter.list = ["nearest", "bilinear", "cubic", "cubic spline", "lanczos", "average", "mode"]
		param.value = "nearest"
		params += [param]
		param = arcpy.Parameter(displayName="Resolution", name="RESOLUTION", direction="Input", parameterType="Optional", datatype="GPString")
		param.filter.list = ["highest", "lowest", "average", "user"]
		param.value = "highest"
		params += [param]
		param = arcpy.Parameter(displayName="Cellsize", name="CELLSIZE", direction="Input", parameterType="Optional", datatype="GPDouble")
		param.value = 1.000000
		params += [param]
		param = arcpy.Parameter(displayName="Align", name="ALIGN", direction="Input", parameterType="Optional", datatype="GPBoolean")
		param.value = True
		params += [param]
		return params

	def execute(self, parameters, messages):
		Tool = ArcSAGA.SAGA_Tool('io_gdal', '12')
		Tool.Set_Option('FILES', parameters[0].valueAsText)
		Tool.Set_Option('FILE_LIST', parameters[1].valueAsText)
		Tool.Set_Option('VRT_NAME', parameters[2].valueAsText)
		Tool.Set_Option('RESAMPLING', parameters[3].valueAsText)
		Tool.Set_Option('RESOLUTION', parameters[4].valueAsText)
		Tool.Set_Option('CELLSIZE', parameters[5].valueAsText)
		Tool.Set_Option('ALIGN', parameters[6].valueAsText)
		Tool.Run()
		return


class tool_14(object):
	def __init__(self):
		self.label = "Create Raster Catalogue from Virtual Raster (VRT)"
		self.description = "<p>The tool allows one to create a polygon layer that shows the extent of each raster file referenced in the virtual raster. Each extent is attributed with the original file path, which can be used to load the dataset by 'CTRL + left-click' in the table field.</p><p></p><p>Note: the tool only supports basic variants of the VRT format.<p><hr><span STYLE=\"font-style:italic;font-size:9pt;font-weight:bold\">SAGA - System for Automated Geoscientific Analyses<br></span><span STYLE=\"font-style:italic;font-size:8pt\">www.saga-gis.org<br></span><span STYLE=\"font-style:italic;font-size:6pt\">_____<br>Reference:<br>Conrad, O., Bechtel, B., Bock, M., Dietrich, H., Fischer, E., Gerlitz, L., Wehberg, J., Wichmann, V., and B__hner, J. (2015): System for Automated Geoscientific Analyses (SAGA) v. 2.1.4, Geosci. Model Dev., 8, 1991-2007, doi:10.5194/gmd-8-1991-2015.</span></p></p>"
		self.canRunInBackground = False

	def getParameterInfo(self):
		param = arcpy.Parameter(displayName="VRT File", name="VRT_FILE", direction="Input", parameterType="Optional", datatype="DEFile")
		params  = [param]
		param = arcpy.Parameter(displayName="Raster Catalogue", name="CATALOGUE", direction="Output", parameterType="Required", datatype="GPFeatureLayer")
		params += [param]
		return params

	def execute(self, parameters, messages):
		Tool = ArcSAGA.SAGA_Tool('io_gdal', '14')
		Tool.Set_Option('VRT_FILE', parameters[0].valueAsText)
		Tool.Set_Output('CATALOGUE', parameters[1].valueAsText, 'shapes')
		Tool.Run()
		return
